{{log "combat-tracker.hbs this" this}}
<section class="{{cssClass}} directory flexcol" id="{{cssId}}" data-tab="{{tabName}}">
    <header class="combat-tracker-header">
        {{#if user.isGM}}
            <nav class="encounters flexrow" aria-label="{{localize 'COMBAT.NavLabel'}}">
                <a class="combat-button combat-create" aria-label="{{localize 'COMBAT.Create'}}" role="button"
                    data-tooltip="COMBAT.Create">
                    <i class="fas fa-plus"></i>
                </a>
                {{#if combatCount}}
                    <a class="combat-button combat-cycle" aria-label="{{localize 'COMBAT.EncounterPrevious'}}"
                        role="button" data-tooltip="COMBAT.EncounterPrevious"
                        {{#if previousId}}data-document-id="{{previousId}}" {{else}}disabled{{/if}}>
                        <i class="fas fa-caret-left"></i>
                    </a>
                    <h4 class="encounter">{{localize "COMBAT.Encounter"}} {{currentIndex}} / {{combatCount}}</h4>
                    <a class="combat-button combat-cycle" aria-label="{{localize 'COMBAT.EncounterNext'}}" role="button"
                        data-tooltip="COMBAT.EncounterNext" {{#if nextId}}data-document-id="{{nextId}}"
                        {{else}}disabled{{/if}}>
                        <i class="fas fa-caret-right"></i>
                    </a>
                {{/if}}
                <a class="combat-button combat-control" aria-label="{{localize 'COMBAT.Delete'}}" role="button"
                    data-tooltip="COMBAT.Delete" data-control="endCombat" {{#unless combatCount}}disabled{{/unless}}>
                    <i class="fas fa-trash"></i>
                </a>
            </nav>
        {{/if}}

        <div class="encounter-controls flexrow {{#if hasCombat}}combat{{/if}}">
            {{#if user.isGM}}
                <a class="combat-button combat-control" aria-label="{{localize 'COMBAT.RollAll'}}" role="button"
                    data-tooltip="COMBAT.RollAll" data-control="rollAll" {{#unless turns}}disabled{{/unless}}>
                    <i class="fas fa-users"></i>
                </a>
                <a class="combat-button combat-control" aria-label="{{localize 'COMBAT.RollNPC'}}" role="button"
                    data-tooltip="COMBAT.RollNPC" data-control="rollNPC" {{#unless turns}}disabled{{/unless}}>
                    <i class="fas fa-users-cog"></i>
                </a>
            {{/if}}

            {{#if combatCount}}
                {{#if combat.round}}
                    <h3 class="encounter-title noborder">{{localize 'COMBAT.Round'}} {{combat.round}}</h3>
                {{else}}
                    <h3 class="encounter-title noborder">{{localize 'COMBAT.NotStarted'}}</h3>
                {{/if}}
            {{else}}
                <h3 class="encounter-title noborder">{{localize "COMBAT.None"}}</h3>
            {{/if}}

            {{#if user.isGM}}
                <a class="combat-button combat-control" aria-label="{{localize 'COMBAT.InitiativeReset'}}" role="button"
                    data-tooltip="COMBAT.InitiativeReset" data-control="resetAll"
                    {{#unless hasCombat}}disabled{{/unless}}>
                    <i class="fas fa-undo"></i>
                </a>
                <a class="combat-button combat-control" aria-label="{{localize 'labels.scope'}}" role="button"
                    data-tooltip="{{labels.scope}}" data-control="toggleSceneLink"
                    {{#unless hasCombat}}disabled{{/unless}}>
                    <i class="fas fa-{{#unless linked}}un{{/unless}}link"></i>
                </a>
            {{/if}}
            <a class="combat-button combat-settings" aria-label="{{localize 'COMBAT.Settings'}}" role="button"
                data-tooltip="COMBAT.Settings" data-control="trackerSettings">
                <i class="fas fa-cog"></i>
            </a>
        </div>
    </header>

    <ol id="combat-tracker" class="directory-list">

        {{!-- {{log "combat-tracker.hbs ===========this" this}} 
        {{log "combat-tracker.hbs ===========turns" turns}} 
        {{log "combat-tracker.hbs ===========combat" combat}}  --}}

        {{!-- {{#each combat.turns}} --}}
        {{#each turns}}
            {{!-- {{log "combat-tracker.hbs AAA this" this}} 
            {{log "combat-tracker.hbs AAA index" @index}} 
            {{log "combat-tracker.hbs AAA lookup (this.combatant) owner" this.combatant }} --}}

            {{#if @root.user.isGM}}
                {{> "systems/ars/templates/sidebar/combat-tracker-actor-entry.hbs"}}
            {{else}}
                {{#if @root.game.ars.config.settings.ctShowOnlyVisible}}
                    {{!-- this check ensures a owner can always seem themselves --}}
                    {{!-- {{#if (lookup (lookup @root.turns @index) owner) }} --}}
                    {{#if this.owner}}
                        {{!-- {{log "combat-tracker.hbs show only visible, is OWNER"}}  --}}
                        {{> "systems/ars/templates/sidebar/combat-tracker-actor-entry.hbs"}}
                    {{else}}
                        {{!-- {{log "combat-tracker.hbs show only visible, NOT THE OWNER this.combatant.token" this.combatant.token}} --}}
                        {{#if this.hidden}}
                            {{!-- {{log "combat-tracker.hbs show only visible, HIDDEN this.combatant.token" this.combatant.token}} --}}
                        {{else}}
                            {{!-- 
                            TODO: bug, test that token.object exists because during load sometimes its not there yet?
                            even when testing it's intermittant. need a way to consistantly make sure it exists. Shows up
                            in Loading XX Assets in logs.
                             --}}
                            {{!-- {{log "combat-tracker.hbs show only visible, NOT HIDDEN this.combatant.token.object" this.combatant.token.object}} --}}
                            {{#if this.combatant.token.object.isVisible}}
                                {{!-- {{log "combat-tracker.hbs show only visible, ISVISIBLE"}} --}}
                                {{!-- {{log "combat-tracker.hbs show only visible, this.token.object.isVisible" this.combatant.token.object.isVisible}}  --}}
                                {{> "systems/ars/templates/sidebar/combat-tracker-actor-entry.hbs"}}
                            {{/if}}
                        {{/if}}
                    {{/if}}
                {{else}}
                    {{!-- {{log "combat-tracker.hbs show only visible, NOT ctShowOnlyVisible"}} --}}
                    {{> "systems/ars/templates/sidebar/combat-tracker-actor-entry.hbs"}}
                {{/if}}
            {{/if}}
            {{!-- {{log "combat-tracker.hbs -----------------------------------"}}  --}}
        {{/each}}
    </ol>

    <nav id="combat-controls" class="directory-footer flexrow" data-tooltip-direction="UP">
        {{#if hasCombat}}
            {{#if user.isGM}}
                {{#if round}}
                    <a class="combat-control" aria-label="{{localize 'COMBAT.RoundPrev'}}" role="button"
                        data-tooltip="COMBAT.RoundPrev" data-control="previousRound"><i
                            class="fas fa-step-backward"></i></a>
                    <a class="combat-control" aria-label="{{localize 'COMBAT.TurnPrev'}}" role="button"
                        data-tooltip="COMBAT.TurnPrev" data-control="previousTurn"><i class="fas fa-arrow-left"></i></a>
                    <a class="combat-control center" aria-label="{{localize 'COMBAT.End'}}" role="button"
                        data-control="endCombat">{{localize 'COMBAT.End'}}</a>
                    <a class="combat-control" aria-label="{{localize 'COMBAT.TurnNext'}}" role="button"
                        data-tooltip="COMBAT.TurnNext" data-control="nextTurn"><i class="fas fa-arrow-right"></i></a>
                    <a class="combat-control" aria-label="{{localize 'COMBAT.RoundNext'}}" role="button"
                        data-tooltip="COMBAT.RoundNext" data-control="nextRound"><i class="fas fa-step-forward"></i></a>
                {{else}}
                    <a class="combat-control center" aria-label="{{localize 'COMBAT.Begin'}}" role="button"
                        data-control="startCombat">{{localize 'COMBAT.Begin'}}</a>
                {{/if}}
            {{else if control}}
                <a class="combat-control" aria-label="{{localize 'COMBAT.TurnPrev'}}" role="button"
                    data-tooltip="COMBAT.TurnPrev" data-control="previousTurn"><i class="fas fa-arrow-left"></i></a>
                <a class="combat-control center" aria-label="{{localize 'COMBAT.TurnEnd'}}" role="button"
                    data-control="nextTurn">{{localize 'COMBAT.TurnEnd'}}</a>
                <a class="combat-control" aria-label="{{localize 'COMBAT.TurnNext'}}" role="button"
                    data-tooltip="COMBAT.TurnNext" data-control="nextTurn"><i class="fas fa-arrow-right"></i></a>
            {{/if}}
        {{/if}}
    </nav>
</section>